// Using statements are used to reference namespaces which contain
// classes used in the source code. To use a namespace, we must first reference
// and assembly, which contains the namespace definitions (see References
// node in the project tree in the Solution Explorer window).
using System;
using System.Collections.Generic;
using System.Text;

namespace Cv1
{
	/// <summary>
	/// Class Program provides a static method Main which is an entry point
	/// to the program.
	/// </summary>
    class Program
    {
		/// <summary>
		/// Program entry point. Iterates through command line arguments
		/// passed to the application and prints them to the standard
		/// output.
		/// </summary>
		/// <param name="args">Command line arguments passed in as a vector of strings.</param>
        static void Main(string[] args)
        {
            // The Length property provides the number of array elements
            System.Console.WriteLine("parameter count = {0}", args.Length);

			// Now we iterate through the array (vector) of arguments
            for (int i = 0; i < args.Length; i++)
            {
                System.Console.WriteLine("Arg[{0}] = [{1}]", i, args[i]);
			}

#region Alternate version
#if USE_FOREACH
			// Alternate version:
			foreach (string arg in args)
			{
				System.Console.WriteLine("{0}", arg);
			}
#endif
#endregion
		}

    }
}
