using System;
using System.Collections;
using System.Text;

namespace Seminar2_2
{
    public class Heap
    {
        private int[] heapList;
        public Heap(int n)
        {
            heapList = new int[n + 1];
            heapList[0] = 0;
        }
        public void insert(int n)
        {
            heapList[heapList[0] + 1] = n;
            int j = heapList[0] + 1;
            while (j > 1 && heapList[j] < heapList[j / 2])
            {   // lazy evaluation grants, that the index will not be out of bounds.
                int pom = heapList[j];
                heapList[j] = heapList[j / 2];
                heapList[j / 2] = pom;
                j = j / 2;
            }
            heapList[0]++;
        }
        public bool isEmpty
        {
            get
            {
                return (heapList[0] == 0);
            }
        }

        public int extract_min
        {
            get
            {
                int min = heapList[1];
                int j = 1;
                int minSon;                 // minimal son
                heapList[1] = heapList[heapList[0]];
                while (j * 2 < heapList[0])
                {
                    minSon = 2 * j;
                    if (heapList[minSon] > heapList[minSon + 1])
                        minSon++;
                    if (heapList[j] > heapList[minSon])
                    {
                        int pom = heapList[j];
                        heapList[j] = heapList[minSon];
                        heapList[minSon] = pom;
                        j = minSon;
                    }
                    else
                        break;
                }
                heapList[0]--;
                return min;
            }
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
//            int[] cisla = { 17, 22, 3, 15, 9, 11, 44, 5, 8, 27, 33, 1, 13, 77, 20, 66, 4, 35, 17 };
            int[] cisla = { 1, 10, 5, 11, 12, 60, 80, 13, 14, 15 };
            Heap hp = new Heap(cisla.Length);
            foreach (int i in cisla)
                Console.Write(i + "\t");
            Console.WriteLine("\n\n");
            foreach (int i in cisla)
                hp.insert(i);
            while (!hp.isEmpty)
                Console.Write(hp.extract_min + "\t");
        }
    }
}
